--- a/Source/g_game.c
+++ b/Source/g_game.c
@@ -181,6 +181,8 @@ int     mousebstrafe;
 int     mousebforward;
 int     joybfire;
 int     joybstrafe;
+int     joybstrafeleft;
+int     joybstraferight;
 int     joybuse;
 int     joybspeed;
 
@@ -213,7 +215,7 @@ int   dclicks2;
 // joystick values are repeated
 int   joyxmove;
 int   joyymove;
-boolean joyarray[5];
+boolean joyarray[9];
 boolean *joybuttons = &joyarray[1];    // allow [-1]
 
 int   savegameslot;
@@ -311,9 +313,9 @@ void G_BuildTiccmd(ticcmd_t* cmd)
     forward += forwardmove[speed];
   if (joyymove > 0)
     forward -= forwardmove[speed];
-  if (gamekeydown[key_straferight])
+  if (gamekeydown[key_straferight] || joybuttons[joybstraferight])
     side += sidemove[speed];
-  if (gamekeydown[key_strafeleft])
+  if (gamekeydown[key_strafeleft] || joybuttons[joybstrafeleft])
     side -= sidemove[speed];
 
     // buttons
@@ -701,6 +703,10 @@ boolean G_Responder(event_t* ev)
       joybuttons[1] = ev->data1 & 2;
       joybuttons[2] = ev->data1 & 4;
       joybuttons[3] = ev->data1 & 8;
+      joybuttons[4] = ev->data1 & 16;
+      joybuttons[5] = ev->data1 & 32;
+      joybuttons[6] = ev->data1 & 64;
+      joybuttons[7] = ev->data1 & 128;
       joyxmove = ev->data2;
       joyymove = ev->data3;
       return true;    // eat events
--- a/Source/i_video.c
+++ b/Source/i_video.c
@@ -72,8 +72,10 @@ void I_JoystickEvents(void)
 
    event_t event;
    int joy_b1, joy_b2, joy_b3, joy_b4;
+   int joy_b5, joy_b6, joy_b7, joy_b8;
    Sint16 joy_x, joy_y;
    static int old_joy_b1, old_joy_b2, old_joy_b3, old_joy_b4;
+   static int old_joy_b5, old_joy_b6, old_joy_b7, old_joy_b8;
    
    if(!joystickpresent || !usejoystick || !sdlJoystick)
       return;
@@ -91,6 +93,14 @@ void I_JoystickEvents(void)
       event.data1 |= 4;
    if((joy_b4 = SDL_JoystickGetButton(sdlJoystick, 3)))
       event.data1 |= 8;
+   if((joy_b5 = SDL_JoystickGetButton(sdlJoystick, 4)))
+      event.data1 |= 16;
+   if((joy_b6 = SDL_JoystickGetButton(sdlJoystick, 5)))
+      event.data1 |= 32;
+   if((joy_b7 = SDL_JoystickGetButton(sdlJoystick, 6)))
+      event.data1 |= 64;
+   if((joy_b8 = SDL_JoystickGetButton(sdlJoystick, 7)))
+      event.data1 |= 128;
    
    // Read the x,y settings. Convert to -1 or 0 or +1.
    joy_x = SDL_JoystickGetAxis(sdlJoystick, 0);
--- a/Source/m_menu.c
+++ b/Source/m_menu.c
@@ -241,6 +241,8 @@ extern int mousebstrafe;
 extern int mousebforward;
 extern int joybfire;
 extern int joybstrafe;                               
+extern int joybstrafeleft;                               
+extern int joybstraferight;                               
 extern int joybuse;                                   
 extern int joybspeed;                                     
 extern int default_weapon_recoil;   // weapon recoil        
@@ -1994,7 +1996,7 @@ void M_DrawSetting(setup_menu_t* s)
 	    }
 	  else
 	    if (key == &key_up   || key == &key_speed ||
-		key == &key_fire || key == &key_strafe)
+		key == &key_fire || key == &key_strafe || key == &key_strafeleft || key == &key_straferight)
 	      {
 		if (s->m_mouse)
 		  sprintf(menu_buffer+strlen(menu_buffer), "/MB%d",
@@ -2348,8 +2350,8 @@ setup_menu_t keys_settings1[] =  // Key
   {"TURN LEFT"   ,S_KEY       ,m_scrn,KB_X,KB_Y+3*8,{&key_left}},
   {"TURN RIGHT"  ,S_KEY       ,m_scrn,KB_X,KB_Y+4*8,{&key_right}},
   {"RUN"         ,S_KEY       ,m_scrn,KB_X,KB_Y+5*8,{&key_speed},0,&joybspeed},
-  {"STRAFE LEFT" ,S_KEY       ,m_scrn,KB_X,KB_Y+6*8,{&key_strafeleft}},
-  {"STRAFE RIGHT",S_KEY       ,m_scrn,KB_X,KB_Y+7*8,{&key_straferight}},
+  {"STRAFE LEFT" ,S_KEY       ,m_scrn,KB_X,KB_Y+6*8,{&key_strafeleft},0,&joybstrafeleft},
+  {"STRAFE RIGHT",S_KEY       ,m_scrn,KB_X,KB_Y+7*8,{&key_straferight},0,&joybstraferight},
   {"STRAFE"      ,S_KEY       ,m_scrn,KB_X,KB_Y+8*8,{&key_strafe},&mousebstrafe,&joybstrafe},
   {"AUTORUN"     ,S_KEY       ,m_scrn,KB_X,KB_Y+9*8,{&key_autorun}},
   {"180 TURN"    ,S_KEY       ,m_scrn,KB_X,KB_Y+10*8,{&key_reverse}},
@@ -3976,8 +3978,8 @@ setup_menu_t helpstrings[] =  // HELP sc
   {"TURN LEFT"   ,S_SKIP|S_KEY,m_null,KT_X3,KT_Y3+ 3*8,{&key_left}},
   {"TURN RIGHT"  ,S_SKIP|S_KEY,m_null,KT_X3,KT_Y3+ 4*8,{&key_right}},
   {"RUN"         ,S_SKIP|S_KEY,m_null,KT_X3,KT_Y3+ 5*8,{&key_speed},0,&joybspeed},
-  {"STRAFE LEFT" ,S_SKIP|S_KEY,m_null,KT_X3,KT_Y3+ 6*8,{&key_strafeleft}},
-  {"STRAFE RIGHT",S_SKIP|S_KEY,m_null,KT_X3,KT_Y3+ 7*8,{&key_straferight}},
+  {"STRAFE LEFT" ,S_SKIP|S_KEY,m_null,KT_X3,KT_Y3+ 6*8,{&key_strafeleft},0,&joybstrafeleft},
+  {"STRAFE RIGHT",S_SKIP|S_KEY,m_null,KT_X3,KT_Y3+ 7*8,{&key_straferight},0,&joybstraferight},
   {"STRAFE"      ,S_SKIP|S_KEY,m_null,KT_X3,KT_Y3+ 8*8,{&key_strafe},&mousebstrafe,&joybstrafe},
   {"AUTORUN"     ,S_SKIP|S_KEY,m_null,KT_X3,KT_Y3+ 9*8,{&key_autorun}},
   {"180 TURN"    ,S_SKIP|S_KEY,m_null,KT_X3,KT_Y3+10*8,{&key_reverse}},
--- a/Source/m_misc.c
+++ b/Source/m_misc.c
@@ -66,6 +66,8 @@ extern int mousebstrafe;
 extern int mousebforward;
 extern int joybfire;
 extern int joybstrafe;
+extern int joybstrafeleft;
+extern int joybstraferight;
 extern int joybuse;
 extern int joybspeed;
 extern int viewwidth;
@@ -1065,6 +1067,20 @@ default_t defaults[] = {
     "joystick button number to use for use/open"
   },
 
+  {
+    "joyb_strafeleft",
+    &joybstrafeleft, NULL,
+    4, {0,UL}, 0, ss_keys, wad_no,
+    "joystick button number to strafe left (sideways left)"
+  },
+
+  {
+    "joyb_straferight",
+    &joybstraferight, NULL,
+    5, {0,UL}, 0, ss_keys, wad_no,
+    "joystick button number to strafe right (sideways right)"
+  },
+
   { // killough
     "snd_channels",
     &default_numChannels, NULL,
@@ -1582,7 +1598,7 @@ default_t defaults[] = {
   {
     "joystick_num",
     &i_SDLJoystickNum, NULL,
-    -1, {-1,UL}, number, ss_none, wad_no,
+    0, {-1,UL}, number, ss_none, wad_no,
     "SDL joystick device number, -1 to disable"
   },
     
